#ifndef BSPLINE_H
#define BSPLINE_H

#include "opengl_stuff.h"
#include <vector>


class BSpline
{
public:
    BSpline(int k = 2, double step = 0.1, int np1 = 6);
    std::vector<GLfloat> const getVertices();
    std::vector<GLfloat> const getNormals();
    std::vector<GLuint> const getIndices();
private:
    std::vector<float> _vecteurNodal;
    std::vector<glm::vec3> _pointsDeControle;
    int _k;
    int _np1;
    double _step;

    std::vector<glm::vec3> _vertices;

    void computeSpline();
    glm::vec3 floraison(float u, int dec, int k, std::vector<glm::vec3> vecteursPointsControle);
};

#endif // BSPLINE_H
